# -*- coding: utf-8 -*-
"""
Created on Tue Feb 23 09:12:57 2016

@author: henrikgs
"""

#Optmod-Gurobi V5_4 Parallell
# -*- coding: utf-8 -*-

import numpy as np
from gurobipy import *
from DBCon3 import *



#Globals
optimizationRun="6_0 _PAR" #versjon av optmod og id for kjøringen: optmod_kjøringID
#Saldoklasser
maxK=3
minK=0
#År
maxT=13
minT=0
#Debug
removedConstr=[]
printInfo=True #Gurobi-status, input- og outputdata printes

def gurobi_work(startOrgnr,sluttOrgnr):
        #Finner skatteposisjoner for alle selskaper fra og med startOrgnummer til sluttOrgnr
        #Selve optimeringen skjer i runOptimization

        print(startOrgnr)
        writeUpdate(0, "Started multithreading running orgs \t"+str(startOrgnr)+"\t and \t"+str(sluttOrgnr)+'\t at time \t'+str(time.strftime("%Y-%m-%d %H:%M:%S")))

        failedco=[]
        failed=1
        skipped=1
        successful=1
        antSelskaper=sluttOrgnr-startOrgnr
        selskapsnr=0

        orgnumre=hentOrgNumre(startOrgnr,sluttOrgnr)
        for i in range(0,len(orgnumre)):
                selskapsnr=selskapsnr+1
                if selskapsnr%10==0: print("Kjører selskapsnr \t",selskapsnr,"\t orgnr: \t",orgnumre[i][0])
                if selskapsnr%50==0: writeUpdate(orgnumre[i][0],str(selskapsnr)+"\t sucessful:\t"+str(successful)+"\t %of unskipped:\t"+str(successful/max(float(selskapsnr-skipped+1),1))+' at time \t'+str(time.strftime("%Y-%m-%d %H:%M:%S")))
                try:
                        out=runOptimization(orgnumre[i][0])
                        if  out==0:
                                #failedco.append(i,orgnumre[i][0])
                                failed=failed+1                 
                        elif out==-1:
                                skipped=skipped+1                 
                        else:
                                outAvvik=out.get('avvikOrig')
                                if outAvvik>-15 and outAvvik<15:
                                        successful=successful+1

                except Exception as e:
                        print(e)
                        time.sleep(60)
                        print('Waited 1 minute after failing on ',orgnumre[i][0])
                        writeUpdate(orgnumre[i][0],'Waited 1 minute after failing on '+str(orgnumre[i][0]))
                        i=i-1
                        continue
                        
                      
        tried=selskapsnr
        print('Tried: ',tried)
        print('Failed: ', failed)
        print('skipped: ', skipped)
        print('Successful: ',successful)
        print('Successful %: ',successful/max(float(tried),1))
        print('Successful of unskipped%: ',successful/max(float(tried-skipped+1),1))
        #print('Succesful within tolerance%: ',sum([1 if x**2<=15**2 else 0 for x in avvik])/float(tried-skipped))
        print('Removed: ',removedConstr)
        print('--')

        #print('valid: ',validateOutput(out))
        print('--')
        #printDict(out)


        return

              
def runOptimization(orgnr): #Henter data fra orgnr, validerer data, kjører OptMod vha Gurobi og laster opp dict med resultatvariabler til DB
        try:
                #Lag Optmod-Modell
                m=Model('OptMod')

                #Legg til variabler
                #Sett
                #K: saldogrupper, K ={0, 1, 2, 3 } der 0 tilsvarer d-inventar, 1 er h-4bygg, 2 er i-2bygg, 3 er j-teknisk
                #T:år, T ={0, 1, ..., 13} der 0 tilsvarer 2001, 13 tilsvarer 2014


                
                teknT=8 #Indeks til 2009 - året tekniske installasjoner innføres - i 2009 skal 60% av bygg 2008 allokeres til IB bygg, 40% til IB tekniske, og begge avskrives i 2009 til gjeldende saldosatss. 2001=0 -> 2009=8

                
                #Parametre
                #(Lovfestede størrelser)
                #ASAVkt: Skattemessig avskrivningssats for gruppe k i
                global ASAV
                ASAV=[
                        [0.15,0.15,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2],#d-inventar, 2001-2014
                        [0.02,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04],#h-4bygg, 2001-2014
                        [0,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02],#i-2bygg, 2001-2014
                        [0,0,0,0,0,0,0,0.10,0.10,0.10,0.10,0.10,0.10,0.10]#j-teknisk, 2001-2014
                ]
                
                #SKTt: Skattesats forår t
                global SKT
                SKT=[0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.27,0.27] #Obs, merk at skattesatsen for NESTE år må være med, ifm.evt. beregning av effekt på utsatt skatt/-fordel

                #Hent regnskapstall fra databasen, valider og set lokale regnskapsvariabler:
                companydatainput=getCompanyData(orgnr)
                printDict(companydatainput)
                if not filterCompany(companydatainput): return -1 #Krav om datapunkter og dataår               
                RAVS=companydatainput.get('RAVS') #RAVSt Regnskapsmessig avskrivning på varige driftsmidler perår t                
                RRES=companydatainput.get('RRES') #RRESt Regnskapsmessig ordinært resultat før skattekostnad perår t
                #print("RRES:",RRES)
                RSKA=companydatainput.get('RSKA') #RSKAt Regnskapsmessig skattekostnad perår t
                RKBD=companydatainput.get('RKBD') #RKBDt Regnskapsmessig konsernbidrag perår t                
                RTBG=companydatainput.get('RTBG') #RTBGt Regnskapsmessig tomter, bygning og annen fast eiendom balanse perår t                
                RINB=companydatainput.get('RINB') #RINBt Regnskapsmessig driftsløsøre/inventar/verktøy/biler balanse perår t                
                RUSK=companydatainput.get('RUSK') #RUSKt Regnskapsmessig utsatt skatt balanse perår t               
                RUSF=companydatainput.get('RUSF') #RUSFt Regnskapsmessg utsatt skattefordel balanse perår t                
                RBSK=companydatainput.get('RBSK') #RBSKt Regnskapsmessig betalbar skatt perår t             
                RSAR=companydatainput.get('RSAR') #RSARt Regnskapsmessig startår (1 førsteåret selskapet har tomt i balansen, 0 ellers)
                RNED=companydatainput.get('RNED') #RNEDt Regnskapsmessige nedskrivninger (eks. nedskrivninger av finansielle driftsmidler)
                
                #Instansier optimeringsvariabler
                rEUS=[];rETB=[];rEIN=[];rINV=[];eINV=[[],[],[],[]];eIBB=[[],[],[],[]];eAVS=[[],[],[],[]];eUBB=[[],[],[],[]];eRFU=[];eFRU=[];eSRE=[];eBSK=[];eEUS=[];eEFR=[] 
                #hjelpevarialber:
                t1=[];t2=[];t3=[];t4=[]
                y1=[];y2=[];y3=[];
                z1=[];z2=[]
                s1=[];s2=[];s3=[]

                #Legg til globale modellvariabler
                eBTY=m.addVar(name='eBTY', vtype=GRB.BINARY) #eBTY Estimert byggtype (1 for h, 0 for i), beslutningsvariabel
                #eBTY=1 #DEBUGGING PURPROSES _ DISABLE BEFORE RUNNING
                
                #Legg til hver årlige modellvariabel til initaliserte array:
                for i in range(minT,maxT+1):                        
                        rEUS.append(0) #rEUSt Regnskapsmessig endring utsatt skatt perår t, kalkulert                        
                        rETB.append(0) #rETBt Regnskapsmessig endring tomter, bygninger og annen fast eiendom balanse perår t, kalkulert                       
                        rEIN.append(0)  #rEINt Regnskapsmessig endring driftløsøre/inventar/verktøy/biler balanse perår t, kalkulert                        
                        rINV.append(0) #rINVt Regnskapsmessig investering perår t, kalkulert
                        for j in range(minK,maxK+1):                                     
                                eINV[j].append(m.addVar(name='eINV', lb=0, vtype=GRB.CONTINUOUS)) #eINVkt Estimert investering i saldogruppe k iår t, beslutningsvariabel                                                  
                                eIBB[j].append(0)  #eIBBkt Estimert inngående balanse per saldkogruppe k perår t                                                          
                                eAVS[j].append(0)  #eAVSkt Estimert saldoavskrivning for saldogruppe kår t                                                     
                                eUBB[j].append(0) #eUBBkt Estimert utgående balanse per saldogruppe k perår t                        
                        eRFU.append(0) #eRFUt Estimert ordinært resultat før fremførbart underskudd forår t                        
                        eFRU.append(m.addVar(name='eFRU', ub=0, vtype=GRB.CONTINUOUS)) #eFRUt Estimert fremførbart underskudd forår t                        
                        eSRE.append(0) #eSREt Estimert skatteresultatår t                        
                        eBSK.append(m.addVar(name='eBSK', lb=0, vtype=GRB.CONTINUOUS)) #eBSKt Estimert betalbar skattår t                       
                        eEUS.append(0)  #eEUSt Estimert endring utsatt skattår t
                        #eEFR.append(0) #Estimert endring fremførbart underskudd år t
                        eEFR.append(m.addVar(name='eEFR',lb=-999999999,vtype=GRB.CONTINUOUS))
                        #Hjelpevariabler obj.funksjon: t1, t2, y1bin for å gjøre |RBSK-eBSK| lineær
                        t1.append(m.addVar(name='t1', lb=0, vtype=GRB.CONTINUOUS))
                        t2.append(m.addVar(name='t2', lb=0, vtype=GRB.CONTINUOUS))
                        y1.append(m.addVar(name='y1',vtype=GRB.BINARY))
                        #Hjelpevariabler obj.funksjon: t3, t4, y2bin for å gjøre |rEUS-eEUS| lineær
                        t3.append(m.addVar(name='t3', lb=0, vtype=GRB.CONTINUOUS))
                        t4.append(m.addVar(name='t4', lb=0, vtype=GRB.CONTINUOUS))
                        y2.append(m.addVar(name='y2',vtype=GRB.BINARY))
                        #Hjelpevariabler for 5.2g, min(sktxesre, 0), som z<=0, z=x-s1, s1 lagt til i objektiv
                        s1.append(m.addVar(name='s1', lb=0, vtype=GRB.CONTINUOUS))
                        #Hjelpevariabler for 5.2e eFRU=min(eSREt-1,0)
                        s2.append(m.addVar(name='s2', lb=0, vtype=GRB.CONTINUOUS))
                        y3.append(m.addVar(name='y3', vtype=GRB.BINARY))    
                        #Hjelpevariabel for eEFR
                        s3.append(m.addVar(name='s3', lb=0, vtype=GRB.CONTINUOUS))
                        
                        #Hjelpe-bigM for aktivering og deaktivering av constraints
                        M=1000000000

                eFRU.append(m.addVar(name='eFRU', ub=0, vtype=GRB.CONTINUOUS))
                s2.append(m.addVar(name='s2', lb=0, vtype=GRB.CONTINUOUS))

                #Integrer nye variabler i modellen (Gurobi lazy)
                m.update()

                #Legg til constraints
                firstyear=RSAR.index(3)
                for i in range(minT,maxT+1):
                        if i==0:
                                rETB[i]=RTBG[i] #5.2k
                        else:
                                rETB[i]=RTBG[i]-RTBG[i-1] #5.2k
                        
                        if i==0:
                                rEIN[i]=RINB[i] #5.2l
                        else:
                                rEIN[i]=RINB[i]-RINB[i-1] #5.2l
                        if i==0 or i==firstyear:
                                rEUS[i]=0 #5.2m - krever også at rEUS er 0 når rEUS t-0 er utilgjengelig i første året
                        else:
                                rEUS[i]=RUSK[i]-RUSK[i-1]-(RUSF[i]-RUSF[i-1]) #5.2m
                        
                        rINV[i]=max(rETB[i]+rEIN[i]+RAVS[i],0) #5.2c     
                        
                        if i<teknT: #Krev investeringer i tekn. inst. kun etter 2008 
                                m.addConstr(eINV[3][i],GRB.LESS_EQUAL,0,"5.2o [%g]" %(i)) #5.2o 
                        m.addConstr(eINV[1][i],GRB.LESS_EQUAL,eBTY*M,"5.2p [%g]" %(i)) #5.2p kan bare investere i en av byggtypene, eBTY=1 for H bygg, k=1
                        m.addConstr(eINV[2][i],GRB.LESS_EQUAL,(1-eBTY)*M,"5.2q [%g]" %(i)) #5.2q kan bare investere i en av byggtypene, eBTY=0 for i bygg, k=2
                        m.addConstr(eINV[0][i],GRB.LESS_EQUAL,max(rEIN[i],0),"5.2 r [%g]" %i) #5.2r - pga høy avskrivningssats forventer vi at inventar-investeringer er mindre maks. impliserte investering i fin.regnskap
                        m.addConstr(rINV[i]*RSAR[i],GRB.GREATER_EQUAL,((eINV[0][i])+(eINV[1][i])+(eINV[2][i])+(eINV[3][i])),"5.2b [%g]" %(i)) #5.2b #kan max investere basert på estimerte finansinvesteringer, MRK, rSAR[0]=3x

                        
                        for j in range(minK,maxK+1):                                      
                                if i==0:
                                        eIBB[j][i]=0 #5.2i
                                else:
                                        eIBB[j][i]=eUBB[j][i-1] #5.2i
                                eAVS[j][i]=(eIBB[j][i]+eINV[j][i])*ASAV[j][i]#5.2d
                                if i!=teknT-1: #Vi setter UBB i 2008 slik at IBB i 2009 har korrekt allokering
                                        eUBB[j][i]=eIBB[j][i]+eINV[j][i]-eAVS[j][i]#5.2j
                                else:
                                        print(i)
                                        print(i+2001)
                                        if j == 1 or j == 2:
                                                eUBB[j][i]=(eIBB[j][i]+eINV[j][i]-eAVS[j][i])*0.6#5.2j
                                        elif j == 3:
                                                eUBB[j][i]=(eIBB[1][i]+eINV[1][i]-eAVS[1][i]+eIBB[2][i]+eINV[2][i]-eAVS[2][i])*0.4#5.2j
                                        elif j == 0:
                                                eUBB[j][i]=(eIBB[j][i]+eINV[j][i]-eAVS[j][i])#5.2j
                       
                        if RSAR[i]!=0:
                                m.addConstr(RTBG[i]*0.2,GRB.LESS_EQUAL,(eUBB[0][i]+eUBB[1][i]+eUBB[2][i]+eUBB[3][i]),"5.2s [%g]" %(i)) #5.2s -- NY CONSTRAINT krav til at saldo er minst 20% av tomter i balansen

                        eRFU[i]=RRES[i]+RAVS[i]-(eAVS[0][i]+eAVS[1][i]+eAVS[2][i]+eAVS[3][i])#5.2f
                                                

                        if i==0:
                                  m.addConstr(eFRU[i],GRB.EQUAL,0,"5.2e %g" %i) #5.2e
                                  m.addConstr(s2[i],GRB.EQUAL,0,"5.2e-s %g" %i) #5.2e        
                        else:
                                  m.addConstr(s2[i],GRB.GREATER_EQUAL,-eSRE[i-1],"5.2e-s2 %g" %i) #5.2e 
                                  eFRU[i]=-s2[i] #5.2e
                                  m.addConstr(eEFR[i-1],GRB.EQUAL,eFRU[i-1]-eFRU[i],"efru")   
                        #m.addConstr(s3[i],GRB.GREATER_EQUAL,eFRU[i])
                        #m.addConstr(s3[i],GRB.GREATER_EQUAL,-eRFU[i])
                        #eEFR[i]=-s3[i]
                        #print(i)
                        #eEFR[i]=eFRU[i]-eFRU[i+1]
                            

                        if i==0 or i==firstyear:
                                eEUS[i]=0#5.2n
                        else:
                                #eEUS[i]=SKT[i]*(eEFR[i]+(eAVS[0][i])+(eAVS[1][i])+(eAVS[2][i])+(eAVS[3][i])-RAVS[i]-RNED[i])+(RUSK[i]-RUSF[i])*(SKT[i+1]-SKT[i]) #5.2n FØR FIKSING AV SKATTEENDR.
                                eEUS[i]=SKT[i]*(-eEFR[i]+(eAVS[0][i])+(eAVS[1][i])+(eAVS[2][i])+(eAVS[3][i])-RAVS[i]-RNED[i])#5.2n   #+((RUSK[i]-RUSF[i])/SKT[i+1]-(eAVS[0][i])+(eAVS[1][i])+(eAVS[2][i])+(eAVS[3][i]))*(SKT[i+1]-SKT[i])       

                        if i==0:
                                eSRE[i]=eRFU[i] #5.2h
                        else:
                                eSRE[i]=eRFU[i]+eFRU[i] #5.2h

                        m.addConstr(eBSK[i],GRB.GREATER_EQUAL,0,"5.2g %g" %i) #5.2g nr 1, linearisert 
                        m.addConstr(s1[i],GRB.GREATER_EQUAL,SKT[i]*(eSRE[i]-RKBD[i]/float(1-(SKT[i]))),"5.2g %g" %i) #5.2g lin
                        eBSK[i]=s1[i] #5.2g nr 1, linearisert
                         
                        #Objektivfunksjon-constraints (Linearisert vha t1,...,t4, y1,y2)
                        #Betalbar skatt
                        m.addConstr(t1[i],GRB.GREATER_EQUAL,0,"t1 %g" %i)
                        m.addConstr(t2[i],GRB.GREATER_EQUAL,0,"t2 %g" %i)
                        m.addConstr(RBSK[i]-eBSK[i],GRB.EQUAL,t1[i]-t2[i],"objp1 %g" %i)
                        m.addConstr(t1[i],GRB.LESS_EQUAL,M*y1[i],"t1 bin %g" %i)
                        m.addConstr(t2[i],GRB.LESS_EQUAL,M*(1-y1[i]),"t2 bin %g" %i)
                        #Endring utsatt skatt
                        m.addConstr(t3[i],GRB.GREATER_EQUAL,0,"t3 %g" %i)
                        m.addConstr(t4[i],GRB.GREATER_EQUAL,0,"t4 %g" %i)
                        m.addConstr(rEUS[i]-eEUS[i],GRB.EQUAL,t3[i]-t4[i],"objp2 %g" %i)
                        m.addConstr(t3[i],GRB.LESS_EQUAL,M*y2[i],"t3 bin %g" %i)
                        m.addConstr(t4[i],GRB.LESS_EQUAL,M*(1-y2[i]),"t4 bin %g" %i)

                        if i==maxT: #Legg til neste års inngående eFRU for å beregne eEFR
                                #print('jepp')
                                m.addConstr(s2[i+1],GRB.GREATER_EQUAL,-eSRE[i],"5.2e-s2 %g" %i) #5.2e 
                                eFRU[i+1]=-s2[i+1] #5.2e

     
                #Legg til objektivfunksjon
                optmodObj=0
                for i in range(minT,maxT+1):
                        optmodObj=optmodObj+(t1[i]+t2[i])
                        if (RUSK!=0 or RUSF!=0) and i!=firstyear:
                                #print("ADDED EUS IN YR "+str(i))
                                optmodObj=optmodObj+(t3[i]+t4[i]) #målfunksjonen skal bare straffes for avvik endring utsatt skatt dersom selskapet fører utsatt skatt

                for i in range(minT,maxT+1):
                        optmodObj=optmodObj+1.1*(s1[i]+s2[i]+s3[i])
                m.setObjective(optmodObj,GRB.MINIMIZE)
                                          
                #Modellkjøring:
                m.update()
                #Set evt. parametre:
                #m.feasRelax
                m.setParam(GRB.Param.Presolve, 0) #-1 auto, 0 av, 1 konservativ, 2 aggressiv
                m.setParam(GRB.Param.NumericFocus,3) #Grad av fokus på numerisk korrekthet, 3 er høy (lav hastighet)
                m.setParam(GRB.Param.TimeLimit,240)
                if not printInfo: m.setParam(GRB.param.OutputFlag,0)  #0 fjerner solver-output fra stdout

                m.optimize()

                status = m.status
                if printInfo: print(m.status)
                
                if status==3:
                    m.computeIIS()
                    m.write('model'+str(orgnr)+'(3).ilp') 
                if status == GRB.Status.UNBOUNDED:
                    print('The model cannot be solved because it is unbounded')
                    m.computeIIS()
                    m.write('model'+str(orgnr)+'unbounded.ilp')
                    #exit(0)
                elif status == GRB.Status.OPTIMAL:
                    print('The optimal objective is %g' % m.objVal)
                    notSolved=False
                    #exit(0)
                elif status != GRB.Status.INF_OR_UNBD and status != GRB.Status.INFEASIBLE:
                    print('Optimization was stopped with status %d' % status)
                    notSolved=True
                    m.computeIIS()
                    m.write('model'+str(orgnr)+'inf.ilp')
                    #exit(0)
                else:
                        notSolved=True


                # Dersom modellen er infeasible, finn begrensende constraint, print, fjern og kjør på nytt
                while notSolved: 
                    return 0 #Aktiver ved modellkjøring - returner 0 (failed) istedenfor å fjerne constraints

                #!!!Eksekveres ikke pga: return 0!!!
                    z=0
                    # do IIS
                    print('The model is infeasible; computing IIS')
                    removed = []
                    m.computeIIS()
                    m.write('model'+str(z)+'.ilp')
                    print('\nThe following constraint cannot be satisfied:')
                    for c in m.getConstrs():
                        if c.IISConstr:
                            print('%s' % c.constrName)
                            # Remove a single constraint from the model
                            removed.append(str(c.constrName))
                            removedConstr.append(str(c.constrName))
                            m.remove(c)
                            z=z+1
                            break
                        
                    print('')

                    m.optimize()
                    status = m.status

                    if status == GRB.Status.UNBOUNDED:
                        print('The model cannot be solved because it is unbounded')
                        #exit(0)
                    elif status == GRB.Status.OPTIMAL:
                        notSolved=False
                    elif status != GRB.Status.INF_OR_UNBD and status != GRB.Status.INFEASIBLE:
                        print('Optimization was stopped with status %d' % status)
                        #notSolved=False
                        #exit(0)

                        print('\nThe following %g constraints were removed to get a feasible LP:' %len(removed))
                        print(removed)
                else:
                        notSolved=False
                        #print('\nThe following %g constraints were removed to get a feasible LP:' %len(removed))


                #Output
                posAvvik=[0]*(maxT+1-minT)
                negAvvik=[0]*(maxT+1-minT)
                netAvvik=[0]*(maxT+1-minT)
                netAbsAvvik=[0]*(maxT+1-minT)
                relAbsAvvik=[0]*(maxT+1-minT-firstyear)
                esreAdj=[0]*(maxT+1-minT)
                esreAbsAdj=[0]*(maxT+1-minT)
                esre=[0]*(maxT+1-minT)
                esreAbs=[0]*(maxT+1-minT)
                for i in range(minT,maxT+1):
                        posAvvik[i]=t1[i].X/SKT[i]+t3[i].X/SKT[i]
                        negAvvik[i]=t2[i].X/SKT[i]+t4[i].X/SKT[i]
                        netAvvik[i]=posAvvik[i]-negAvvik[i]
                        netAbsAvvik[i]=abs(netAvvik[i])
                        esreAdj[i]=eSRE[i].getValue()+posAvvik[i]-negAvvik[i]
                        esreAbsAdj[i]=abs(esreAdj[i])
                        esre[i]=eSRE[i].getValue()
                        esreAbs[i]=abs(esre[i])
                        relAbsAvvik[i-firstyear]=abs(netAvvik[i]/esreAdj[i]) if esreAdj[i]!=0 else 0
                print("Avvik: " + str(sum(relAbsAvvik)/len(relAbsAvvik)))
                avvikDev=sum(relAbsAvvik)/len(relAbsAvvik)
                avvikOrig=(sum(posAvvik)+sum(negAvvik))/(sum(esreAbs)-sum(posAvvik)+sum(negAvvik))
                #print(netAbsAvvik)
                #print(esreAdj)
                avvikAlt=sum(netAbsAvvik)/sum(esreAbsAdj)
                #print('AVVIKMAX: ', avvikMax)                        
                outputDict={
                        'OptMod':optimizationRun,
                        's1':getParamValues(s1),
                        's2':getParamValues(s2),
                        's3':getParamValues(s3),
                        't1':getParamValues(t1),
                        't2':getParamValues(t2),
                        't3':getParamValues(t3),
                        't4':getParamValues(t4),
                        'RSAR':getParamValues(RSAR),
                        'rEUS':getParamValues(rEUS),
                        'eEUS':getParamValues(eEUS),
                        'rETB':getParamValues(rETB),
                        'rINV':getParamValues(rINV),
                        'eRFU':getParamValues(eRFU),
                        'eFRU':getParamValues(eFRU),
                        'eEFR':getParamValues(eEFR),
                        'eSRE':getParamValues(eSRE),
                        'eBSK':getParamValues(eBSK),
                        'RBSK':getParamValues(RBSK),
                        'eINV0':getParamValues(eINV[0]),
                        'eIBB0':getParamValues(eIBB[0]),
                        'eAVS0':getParamValues(eAVS[0]),
                        'eUBB0':getParamValues(eUBB[0]),
                        'eINV1':getParamValues(eINV[1]),
                        'eIBB1':getParamValues(eIBB[1]),
                        'eAVS1':getParamValues(eAVS[1]),
                        'eUBB1':getParamValues(eUBB[1]),
                        'eINV2':getParamValues(eINV[2]),
                        'eIBB2':getParamValues(eIBB[2]),
                        'eAVS2':getParamValues(eAVS[2]),
                        'eUBB2':getParamValues(eUBB[2]),
                        'eINV3':getParamValues(eINV[3]),
                        'eIBB3':getParamValues(eIBB[3]),
                        'eAVS3':getParamValues(eAVS[3]),
                        'eUBB3':getParamValues(eUBB[3]),
                        'eEFR':getParamValues(eEFR),
                        'avvikDev':100*avvikDev,
                        'avvikAlt':100*avvikAlt,
                        'avvikOrig':100*avvikOrig,
                        'eBTY':getParamValues(eBTY)
                        }

                if notSolved:
                        return 0
                else:
                        if printInfo: printDict(companydatainput)
                        if printInfo: printDict(outputDict)
                        uploadData(orgnr,outputDict)
                        
                        return outputDict

        
        except GurobiError:
            print('Error under kjøringen')
            print(GurobiError.message)
            return 0


def writeUpdate(orgnr, message): #Skriver oppdatering av kjørestatus til fil 
        with open("gurobiRunning.txt", "a") as myfile:
                writeString="orgnr:\t"+str(orgnr)+'\t'+str(message)+'\r\n'
                myfile.write(writeString)

def getCompanyData(orgnr): #Henter ut selskapsdata, avhengig av hentPostVerdier (import DBCon2)   
        RTBGtemp=padData(hentPostVerdier("Tomter, bygninger og annen fast",orgnr))#Regnskapsmessig tomter, bygning og annen fast eiendom balanse perår t
        switcher={
           'RRES':padData(hentPostVerdier("Ordinært resultat før skattekost",orgnr)),#Regnskapsmessig ordinrt resultat før skattekostnad per t
           'RSKA':padData(hentPostVerdier("Skattekostnad på ordinært result",orgnr)),#Regnskapsmessig skattekostnad perår t
           'RKBD':padData(hentPostVerdier("Konsernbidrag",orgnr)),#Regnskapsmessig konsernbidrag perår t
           'RTBG':RTBGtemp,
           'RINB':padData(hentPostVerdier("Driftsløsøre, inventar, verktøy,",orgnr)),#Regnskapsmessig driftsløsøre/inventar/verktøy/biler balanse perår t
           'RUSK':padData(hentPostVerdier("Utsatt skatt",orgnr)),#Regnskapsmessig utsatt skatt balanse perår t
           'RUSF':padData(hentPostVerdier("Utsatt skattefordel",orgnr)),#Regnskapsmessig utsatt skattefordel balanse perår t
           'RBSK':padData(hentPostVerdier("Betalbar skatt",orgnr)),#Regnskapsmessig betalbar skatt perår t
           'RSAR':[min(x,1) for x in RTBGtemp],
           'RSAR2':[min(x,1) for x in RTBGtemp],
           'RAVS':padData(hentPostVerdier("Avskrivning på varige driftsmidl",orgnr)),#Regnskapsmessige avskrivninger på varige driftsmidler
           'RSVD':padData(hentSumVarigeDriftsmidler(orgnr)),#Sum varige driftsmidler
           'RNED':padData(hentSumNedskrivninger(orgnr)) #Sum nedskrivninger
        }
        for i in range(minT,maxT): #Første året med tomt i balansen tillates det en ekstra investering, iom. at start-saldobalanse sannsynligvis er høyere enn start-finansbalanse
                cur=switcher.get('RSAR')[i]
                t=switcher.get('RSAR')[i+1]
                if cur==0 and t==1:
                        switcher.get('RSAR')[i+1]=3 #Her er det tillatt max. en 3x multippel på finansbalansen som initiell saldo
        return switcher

def filterCompany(inputdict): #tar inn paddet dict med companydata fra (fortrv.) runOptimization() og returnerer True om selskapet tilfredstiller kjørekriterier, og false om det ikke er tilstrekkelig data - optmod skal isåfall breake og gå til neste selskap
        try:
                RTBG=inputdict.get('RTBG') #Balanse tomter og bygg
                RSVD=inputdict.get('RSVD') #Regnskapsmessig sum varige driftsmidler
                RelRTBG=[] #Tomter og bygg som % av varige driftsmidler
                RBSKyr=0
                RUSKyr=0
                RUSFyr=0              
                
                
                #Antall år med data - år der det er tomt/bygg-balanse
                datayr=sum([1 if x!=0 else 0 for x in inputdict.get('RSAR')])
                

                #Antall år med skattedata for relevante år (år med tomt i balansen)
                for i in range(minT,maxT+1):
                        if inputdict.get('RBSK')[i]*inputdict.get('RSAR')[i] !=0:
                                RBSKyr=RBSKyr+1
                        if inputdict.get('RBSK')[i]*inputdict.get('RSAR')[i] ==0 and inputdict.get('RKBD')[i]*inputdict.get('RSAR')[i] !=0: #År med null i betalbar skatt, men med konsernbidrag, skal gi uttelling som data
                                RBSKyr=RBSKyr+1
                        if inputdict.get('RUSK')[i]*inputdict.get('RSAR')[i] !=0:
                                RUSKyr=RUSKyr+1
                        if inputdict.get('RUSF')[i]*inputdict.get('RSAR')[i] !=0:
                                RUSFyr=RUSFyr+1
                        #Bygg/tomt som andel av varige driftsmidler
                        if RSVD[i]!=0 and i<8:
                                RelRTBG.append(RTBG[i]/float(RSVD[i]))
                        else:
                                RelRTBG.append(1)
                                
                postyr=(RBSKyr+RUSKyr+RUSFyr) / float(datayr)                
                minRelRTBG=min(RelRTBG)
                
                #Krav                
                datakrav=1 #Krever at for hvert relevante år har man 1 av 2 poster som gir info om fremf. underskudd
                yrkrav=7 #Krever at man har 7 år med bygg/tomt-balanse
                byggkrav=0.8 #Krevet at 80% av varige driftsmidler er i bygg/tomt OBS! KUN FOR ÅR FØR 2009, IOM. AT TEKNISKE INSTALLASJONER KAN GÅ I INVENTAR-BALANSE
                if datakrav <= postyr and yrkrav <= datayr and byggkrav <= minRelRTBG:
                        return True
                else:
                        return False
        except:
                 return False  #returner false i tilfelle data ikke eksisterte => div0-error


def getParamValues(name): #returnerer et array der Gurobi-var og Gurobi-LinExpr objekter er oversatt til primitiver / floats
        output=[]
        if type(name)==list:
                for i in range(0,len(name)):
                        if type(name[i])==gurobipy.LinExpr:
                                output.append(round(name[i].getValue(),2))
                        elif type(name[i])==gurobipy.Var:
                                output.append(round(name[i].X,2))
                        else:
                                output.append(round(name[i],2))
        else:
                if type(name)==gurobipy.LinExpr:
                        output=(round(name.getValue(),2))
                elif type(name)==gurobipy.Var:
                        output=(round(name.X,2))
                else:
                        output=(round(name,2))
        return output

def uploadData(orgnr,outputDict): #laster opp resultater fra Optimization til databasen avhengig av lagreResultater (import DBCon2)
        #Upload dataDict to database
        lagreResultater(orgnr,outputDict,optimizationRun)
        return True

def validateOutput(outputDict): #validerer at lineariserte/lazy constraints holder
        valid = True

        #Setup - hent alle variabler
        ver=outputDict.get('OptMod')
        s1=outputDict.get('s1')
        s2=outputDict.get('s2')
        t1=outputDict.get('t1')
        t2=outputDict.get('t2')
        t3=outputDict.get('t3')
        t4=outputDict.get('t4')
        RSAR=outputDict.get('RSAR')
        rEUS=outputDict.get('rEUS')
        eEUS=outputDict.get('eEUS')
        rETB=outputDict.get('rETB')
        rINV=outputDict.get('rINV')     
        eRFU=outputDict.get('eRFU')
        eFRU=outputDict.get('eFRU')
        eSRE=outputDict.get('eSRE')
        eBSK=outputDict.get('eBSK')
        RBSK=outputDict.get('RBSK')
        eINV0=outputDict.get('eINV0')
        eIBB0=outputDict.get('eIBB0')
        eAVS0=outputDict.get('eAVS0')
        eUBB0=outputDict.get('eUBB0')
        eINV1=outputDict.get('eINV1')
        eIBB1=outputDict.get('eIBB1')
        eAVS1=outputDict.get('eAVS1')
        eUBB1=outputDict.get('eUBB1')
        eINV2=outputDict.get('eINV2')
        eIBB2=outputDict.get('eIBB2')
        eAVS2=outputDict.get('eAVS2')
        eUBB2=outputDict.get('eUBB2')
        eINV3=outputDict.get('eINV3')
        eIBB3=outputDict.get('eIBB3')
        eAVS3=outputDict.get('eAVS3')
        eUBB3=outputDict.get('eUBB3')                
        avvikMax=outputDict.get('avvikMax')
        eBTY=outputDict.get('eBTY')
        for i in range(minT,maxT+1):
                #Sjekk hjelpevariabler
                if t1[i]!=0 and t2[i]!=0: valid = False;
                if t2[i]!=0 and t1[i]!=0: valid = False;
                if t3[i]!=0 and t4[i]!=0: valid = False;
                if t4[i]!=0 and t3[i]!=0: valid = False;
                if not int(t1[i]+t2[i])==int(abs(RBSK[i]-eBSK[i])): valid = False; #5.2a
                if not int(t3[i]+t4[i])==int(abs(rEUS[i]-eEUS[i])): valid = False; #5.2a
                if i!=0 and not int(eFRU[i])==int(min(eSRE[i-1],0)): valid = False; #5.2e
                if i==0 and not int(eFRU[i])==0: valid = False; #5.2e
                if i!=0 and eSRE[i-1]<0 and eFRU[i]!=eSRE[i-1]: valid=False; #5.2e
               # if not int(eBSK[i])==int(max(SKT[i]*eSRE[i],0)): valid = False; #5.2g
                #print(int(eBSK[i])==int(max(SKT[i]*eSRE[i],0)),' ',eBSK[i],' ',SKT[i],' ',eSRE[i],' ',SKT[i]*eSRE[i],' ',i)
                if int(eINV1[i])!=0 and int(eINV2[i])!=0: valid = False ;#5.2p-q
                
        return valid
                          
  
        


def printSolution(m): #Printer løsningen, men må være instansiert etter Gurobi / evt bruke globale var
        if m.status==GRB.Status.OPTIMAL:
                print('Obj.funksjon %g' %m.objVal)
                print ('s1 '+str(quicksum(s1).getValue()))
                print ('s2 '+str(quicksum(s2).getValue()))
                print ('z1 '+str(quicksum(t1+t2).getValue()))
                print ('z2 '+str(quicksum(t3+t4).getValue()))
                print('Avvik (obj.funksjon ex.slack) %g' % (m.objVal-quicksum(s1).getValue()-quicksum(s2).getValue()))
                avvik=quicksum(t1+t2+t3+t4).getValue()
                skatteresmin=quicksum(eSRE).getValue()-avvik
                avvikMax=avvik/float(skatteresmin)
                print('Avvik max:' + str(avvikMax))
                print('Avvik avg:' + str(avvik/(skatteresmin+avvik)))
                print('eBTY' + '\t' + str(eBTY.X))
                print('H-bygg, 4% avskr.') if eBTY.X>=1 else print('I-bygg, 2% avskr.');
                print ('t:\t' + "\t".join([str(x) for x in range(minT,maxT+1)]))
                print ('t1' + printVarArray(t1))
                print ('t2' + printVarArray(t2))
                print ('t3' + printVarArray(t3))
                print ('t4' + printVarArray(t4))
                                        
                print ('rEUS' + printVarArray(rEUS))
                print ('eEUS' + printVarArray(eEUS))
                print ('rETB' + printVarArray(rETB))
                print ('rEIN' + printVarArray(rEIN))
                print ('rINV' + printVarArray(rINV))
               
                print ('eRFU' + printVarArray(eRFU))
                print ('eFRU' + printVarArray(eFRU))
                print ('eSRE' + printVarArray(eSRE))
                print ('eBSK' + printVarArray(eBSK))
                print ('RBSK' + printVarArray(RBSK))
                
                for k in range(minK,maxK+1):
                        print ('eINV_' + str(k) + printVarArray(eINV[k])) #fourK
                        print ('eIBB_' + str(k) + printVarArray(eIBB[k])) #fourK
                        print ('eAVS_' + str(k) + printVarArray(eAVS[k])) #fourK
                        print ('eUBB_' + str(k) + printVarArray(eUBB[k])) #fourK
        else:
                print("Status not optimal when printSolution was called!")                

    return True
    
def padData(inputdict): #Tar database-dictionary med år-nøkler og pad'er til 0-indeksert 2001
        outputlist=[0 for x in range(minT,maxT+1)]
        #print (inputdict)
        for i in range(minT,maxT+1):
                outputlist[i]=inputdict.get(2001+i) if not inputdict.get(2001+i)==None else 0
        return outputlist
        


def printDict(inputdict): #Printer en tab-delimited sortert inputDict
        for x in sorted(inputdict.keys(), key=lambda x: x[1:]):
                if type(inputdict.get(x)) is list:
                        print (str(x),'\t','\t'.join([str(int(y)) for y in inputdict.get(x)]).expandtabs(12))
                else:
                        print (str(x),'\t','\t',inputdict.get(x))

def printVarArray(name):
        outputstr=""
        delimeter="\t" #tab-delimeted
        for i in range(0,len(name)):
                temp=name[i]
                if type(name[i])==gurobipy.LinExpr:
                        outputstr=outputstr + delimeter + str(round(name[i].getValue(),1))
                elif type(name[i])==gurobipy.Var:
                        outputstr=outputstr+delimeter+str(round(name[i].X,1))
                else:
                        outputstr=outputstr+delimeter+str(round(name[i],1))
        return outputstr
