# -*- coding: utf-8 -*-
"""
Created on Thu Jun  9 18:48:08 2016

@author: tallakb
"""

# -*- coding: utf-8 -*-


import numpy as np
import pandas
import time
import random

from BeregnAvvik import finnAvvikFraPerpetuitetsantakelsen

ASAV=[
        [0.2,0.15,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2],#d-inventar, 2001-2014
        [0.02,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04],#h-4bygg, 2001-2014
        [0,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02],#i-2bygg, 2001-2014
        [0,0,0,0,0,0,0,0.10,0.10,0.10,0.10,0.10,0.10,0.10]#j-teknisk, 2001-2014
] #Avskrivningssats

def padData(inputdict): #Tar database-dictionary med år-nøkler og pad'er til 0-indeksert 2001
        maxT=13
        minT=0
        outputlist=[0 for x in range(minT,maxT+1)]
        #print (inputdict)
        for i in range(minT,maxT+1):
                outputlist[i]=inputdict.get(2001+i) if not inputdict.get(2001+i)==None else 0
        return outputlist
 
 
def normDraw(mu,std,x=1): #Returns x-sized list of stochastic observations from norm(mu,sigma)
    out=np.random.normal(mu,std,x).tolist()
    return out



def writeUpdate(sim_pid, message): #Skriver oppdatering av kjørestatus til fil 
        with open("finnAvvikRunning.txt", "a") as myfile:
                writeString="sim_pid:\t"+str(sim_pid)+'\t'+str(message)+'\r\n'
                myfile.write(writeString)


def sim_work(orgnrdato, iterasjoner,simuleringsÅr,simKommentar,future): 
    #For parallell-kjøring av Monte Carlo simuleringer
    #Kaller simulerOgLagre for en kombinasjon av (orgnummer, kjøredato) med iterasjoner, antall simuleringsår, simuleringskommentar og True/False for fremtidig eller historisk simulering
    sim_pid=random.randint(1000,2000)
    writeUpdate(str(sim_pid)," started running")
    allowedattempts=10
    print("Starter ny simulering")
    for orgdatotuple in orgnrdato:
        print("Starter orgnummer, ",orgdatotuple[0])
        attempt=0
        unsuccessful=True
        while unsuccessful:
            try:
                simulerOgLagre(orgdatotuple[0], orgdatotuple[1], iterasjoner, simuleringsÅr, simKommentar,future)
                unsuccessful=False
            except Exception as exptsim:
                print(exptsim)
                attempt+=1
                writeUpdate(str(sim_pid),"encountered error " + str(exptsim) + " while running orgnr " + str(orgdatotuple[0]) + " attempt " + str(attempt))
                if attempt>=allowedattempts:
                    writeUpdate(str(sim_pid),"is skipping, after encountered error " + str(exptsim) + " while running orgnr " + str(orgdatotuple[0]) + " after attempts:" + str(attempt))
                    unsuccessful=False
                else:
                    time.sleep(60)
            




#simulerOgLagre(979506619,"2016-05-23",1,30,"5_7_PAR")
def simulerOgLagre(orgnummer,kjøredato,iterations,simuleringsÅr,simKommentar,future=False):  
    parametre=estimerParametre(orgnummer,kjøredato,"fff",simuleringsÅr)
    #print(parametre)
    if(parametre['valid']==False):
        print("Parametrene er ikke gyldige")
        return False    
    
    eiendeler=parametre['eiendeler']
    ROA=parametre['ROA']
    
    startÅr=parametre['startÅr']
    sluttÅr=parametre['sluttÅr']
    SUavsk=parametre['SUavsk']
    AVSK0=parametre['AVSK0'] #Den siste avskrivningen fra estimerParametre for saldogruppe 0
    AVSK1=parametre['AVSK1'] #Den siste avskrivningen fra estimerParametre for saldogruppe 1
    AVSK2=parametre['AVSK2'] #Den siste avskrivningen fra estimerParametre for saldogruppe 2
    AVSK3=parametre['AVSK3'] #Den siste avskrivningen fra estimerParametre for saldogruppe 3
    AVS0DB=list(parametre.get('AVS0DB'))[:] #Array over historiske avskrivninger for selskapet
    AVS1DB=list(parametre.get('AVS1DB'))[:] #Array over historiske avskrivninger for selskapet
    AVS2DB=list(parametre.get('AVS2DB'))[:] #Array over historiske avskrivninger for selskapet
    AVS3DB=list(parametre.get('AVS3DB'))[:] #Array over historiske avskrivninger for selskapet
          
    histROA=ROA[startÅr:sluttÅr+1]
    avgHistROA=sum(histROA)/len(histROA)
    stdevHistROA=np.std(histROA)

    TIsim=[0]*(simuleringsÅr+40)
    eRFU=[]

    
    #Her starter selve iterasjonen gjennom matrisen med avvik
    sumAvvik = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y
    avgAvvik = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y
    sumNvperp = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y
    avgNvperp = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y
    sumNvreell = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y
    avgNvreell = [[0 for x in range(12)] for y in range(17)]  #factorincrease på x, rente på y

    years = simuleringsÅr #Number of firm-years to simulate per iteration

    #Sett opp initielle avskrivninger
    if future:
            AVS0=[AVS0DB[sluttÅr]] #Dersom future sim: sett avskrivninger til den siste historiske avskrivninger
            AVS1=[AVS1DB[sluttÅr]]
            AVS2=[AVS2DB[sluttÅr]]
            AVS3=[AVS3DB[sluttÅr]]
    else:
            AVS0=[AVS0DB[startÅr]] #Dersom historisk sim: sett avskrivninger til den første historiske
            AVS1=[AVS1DB[startÅr]]
            AVS2=[AVS2DB[startÅr]]
            AVS3=[AVS3DB[startÅr]]                        
    for y in range(1,years): #Føy til resterende avskrivninger. Merk at for future sim blir disse ikke korrekte, men det har ikke noe å si - finnAvvik beregner korrekte basert på den første avskrivningen
        AVS0.append(0)#AVS0[y-1])*(1-ASAV[0][13]))
        AVS1.append(0)#AVS1[y-1]*(1-ASAV[1][13]))
        AVS2.append(0)#AVS2[y-1]*(1-ASAV[2][13]))
        AVS3.append(0)#AVS3[y-1]*(1-ASAV[3][13]))    
    t0 = time.clock()
    for iteration in range(0,iterations):        
        if(iteration%100==0):
            randomt0 = time.clock()            
        #randomTall=normDraw(0,math.sqrt(parametre['sigma2']),simuleringsÅr+1)                
        for t in range(sluttÅr,simuleringsÅr+sluttÅr):
            #ROA[t+1]=parametre['mean']+parametre['rho']*ROA[t]+randomTall[t-sluttÅr]
            #ROA[t+1]=histROA[random.randint(0,len(histROA)-1)]
            ROA[t+1]=normDraw(avgHistROA,stdevHistROA)[0]
            eiendeler[t+1]=eiendeler[t]+ROA[t]*eiendeler[t]*(1-0.28)    # Må fikse noe utbytte her, tror jeg. #TODO
            TIsim[t+1]=round(ROA[t+1]*eiendeler[t+1],3)

        simulatedPreTaxPreDeprEarnings = TIsim[sluttÅr+1:simuleringsÅr+sluttÅr+1]
        eRFU=[simulatedPreTaxPreDeprEarnings[iterator] - AVS0[iterator] -AVS1[iterator] -AVS2[iterator] -AVS3[iterator] for iterator in range(0, len(simulatedPreTaxPreDeprEarnings))]
        
        inputdict={'eRFU':eRFU,
                   'eSRE':'empty',
                   'AVS0':AVS0,
                   'AVS1':AVS1,
                   'AVS2':AVS2,
                   'AVS3':AVS3,
                   'AVS0DB':list(parametre.get('AVS0DB'))[:],
                   'AVS1DB':list(parametre.get('AVS1DB'))[:],
                   'AVS2DB':list(parametre.get('AVS2DB'))[:],
                   'AVS3DB':list(parametre.get('AVS3DB'))[:]
                }
          
        if(iteration%100==0):
            startprosess = time.clock()
            #print(ROA)       
        #faktorøkninger
        for c in range(0,11):
            sumAvvik[0][c+1]=0.2*(c)
            avgAvvik[0][c+1]=0.2*(c)
        for d in range(0,16):
            sumAvvik[d+1][0]=1+0.01*(d)
            avgAvvik[d+1][0]=1+0.01*(d)            
        for i in range(1,12): # i er faktorøkning 
            factorIncrease=avgAvvik[0][i] #0.2*(i-1)    
            for j in range(1,17): # j er avkastningskrav       
                discountRate=avgAvvik[j][0] #1+0.01*(j-1)
                #Setup simulation parameters

                outdict= finnAvvikFraPerpetuitetsantakelsen(orgnummer, factorIncrease, kjøredato, discountRate-1, inputdict, True, True,simuleringsÅr) #Siste 3 params: future, sim, ant år
                avvik = outdict.get('avvik')
                nvperp=outdict.get('deltaperp')
                nvreell=outdict.get('deltareell')
                
                
                sumAvvik[j][i]=avvik +sumAvvik[j][i]
                sumNvperp[j][i]=nvperp+sumNvperp[j][i]
                sumNvreell[j][i]=nvreell+sumNvreell[j][i]

        if(iteration%100==0):
            print( time.clock() - startprosess, "sekunder å gjøre 100 beregninger"    )
        
    #Starter å regne avvikene
    for i in range(1,17): # i er avkasningskrav
        for j in range(1,12): # j er faktorøkning
            avgAvvik[i][j]=sumAvvik[i][j]/iterations
            avgNvperp[i][j]= sumNvperp[i][j]/iterations
            avgNvreell[i][j]=sumNvreell[i][j]/iterations
    #Starter å lagre i databasen

    lagreSimuleringsResultater(orgnummer,avgAvvik,time.strftime("%Y-%m-%d")," nn ",simKommentar,simuleringsÅr,avgNvperp,avgNvreell) 
    print( time.clock() - t0, "seconds total process time"    )
    #printDict(parametre)
    return True

def printDict(inputdict): #Printer en tab-delimited sortert inputDict
        for x in sorted(inputdict.keys(), key=lambda x: x[1:]):
                if type(inputdict.get(x)) is list:
                        print (str(x),'\t','\t'.join([str(int(y)) for y in inputdict.get(x)]).expandtabs(12))
                else:
                        print (str(x),'\t','\t',inputdict.get(x))


def estimerParametre(orgnummer,dato,modellversjon,simuleringsÅr):
    printInfo=False
    #Vi må først hente alle parametre vi skal benytte senere. 
    output={}
    antÅr=14;
    unsucessfulGet=True
    valid=True
    startÅr=0
    
    while unsucessfulGet:
        try:    
                    eRFU= hentEstimater(orgnummer,dato, "eRFU")[0][3:17]; # Dette er før fremførbart underskudd
                    AVS0= hentEstimater(orgnummer,dato, "eAVS0")[0][3:17]; #Avskrivninger fra de forskjellige klassene. 
                    AVS1= hentEstimater(orgnummer,dato, "eAVS1")[0][3:17];
                    AVS2= hentEstimater(orgnummer,dato, "eAVS2")[0][3:17];
                    AVS3= hentEstimater(orgnummer,dato, "eAVS3")[0][3:17];
                    AVS0DB=AVS0[:]
                    AVS1DB=AVS1[:]
                    AVS2DB=AVS2[:]
                    AVS3DB=AVS3[:]
                 
                    ROA=[0]*(antÅr+simuleringsÅr+1) #Return on assets ex. avskrivninger. Lager arrayet stort nok for å holde alle simulerte verdier              
                    deltaROA=[0]*(antÅr+simuleringsÅr) #delta Return on assets ex. avskrivninger. Lager arrayet stort nok for å holde alle simulerte verdier
                    eiendeler=[0]*(antÅr+simuleringsÅr+1)
                    
                    SR = [0]*(antÅr+simuleringsÅr) #Skatteresultat før avskrivninger før fremførbart underskudd
                    SSR = [0]*(antÅr+simuleringsÅr) #Sum skatteresultat, altså inkludert inngående fremførbart underskudd, men ikke avskrivninger
                    AVSK=[0]*(antÅr+simuleringsÅr); #Sum avskrivninger
                    AVSKØkt=[0]*(antÅr+simuleringsÅr) #Sum avskrivninger etter saldoøkning
                    IFU=[0]*(antÅr+simuleringsÅr); #Innkommende fremførbart underskudd som ikke kommer av avskrivninger
                    SUavsk= [0]*((antÅr+simuleringsÅr)+1) #Sum ubenyttede avskrivninger
                    SUavskØkt=[0]*((antÅr+simuleringsÅr)+1) #Sum ubenyttede avskrivninger etter økning
                    BAvsk= [0]*(antÅr+simuleringsÅr) #Sum benyttede avskrivninger
                    BAvskØkt= [0]*(antÅr+simuleringsÅr) #Sum benyttede avskrivninger etter økning
                    initAVSK=[[0]*antÅr,[0]*antÅr,[0]*antÅr,[0]*antÅr]
                    # Nå skal vi hente eiendeler fra finansregnskapet
                    sumEiendeler=padData(hentPostVerdier("Sum eiendeler",orgnummer))
                            
                    if printInfo: 
                                print("Sum eiendeler",sumEiendeler)
                                print("eRFU",eRFU)
                                print("AVS0",AVS0)
                                print("AVS1",AVS1)
                                print("AVS2",AVS2)
                                print("AVS3",AVS3)
                    
                    unsucessfulGet=False
        except Exception as e:
                    #time.sleep(60)
                    print(e)
                    print('Failed at getting estimates for orgnr:\t'+str(orgnummer))
                    valid=False
                    output['valid']=valid
                    return output
                    unsucessfulGet=True
    
    #START PÅ KOPI fra finnAvvik, unntatt *AVSKØKT
    for t in range(0,antÅr): #Range er (inklusiv, eksklusiv)
        AVSK[t]=AVS0[t]+AVS1[t]+AVS2[t]+AVS3[t] #summerer opp alle avskrivninger
        
        
    firstYear=-1 #Første år med tall for byggsaldo
    for t in range(0,antÅr): #Finn startår for byggsaldo - dette brukes for å sette UBB saldoer å beregne mindreavsk.fradrag av
        if (AVS1[t]!=0 or AVS2[t]!=0) and firstYear==-1:
            firstYear=t
            initAVSK[0][t]=AVS0[t]
            initAVSK[1][t]=AVS1[t]
            initAVSK[2][t]=AVS2[t]
            initAVSK[3][t]=AVS3[t]
            if (initAVSK[0][t]+initAVSK[1][t]+initAVSK[2][t]+initAVSK[3][t])==0: print('problem')

    #Beregn avskrivninger fra initiell saldobalanse - m.avsk.fradrag skal kompensere for de eksisterende saldoverdiene, ink. evt. fordeling til j-Tekniske Installasjoner, men altså eks. s.avsk fra investeringer, og med faktorøkning
    for t in range(firstYear,antÅr):
        if firstYear<8 and t==8:#Dersom startåret er før 2009 skal UB byggsaldo_initiell 2008 fordeles 40% til tekniske installasjoner
                initAVSK[3][t]=0.4*(initAVSK[1][t]/ASAV[1][t]+initAVSK[2][t]/ASAV[2][t])*ASAV[3][t]
                initAVSK[1][t]=0.6*initAVSK[1][t]
                initAVSK[2][t]=0.6*initAVSK[2][t]
                
        for k in range(0,3):
            if t!=antÅr-1:
                initAVSK[k][t+1] = (1-ASAV[k][t])*initAVSK[k][t]
           
    for t in range(0,antÅr):
        SR[t]=eRFU[t]+initAVSK[0][t]+initAVSK[1][t]+initAVSK[2][t]+initAVSK[3][t]; #Skatteresultat for selskapet før avskrivninger og fremførbart underskudd
        #Vi legger derfor avskrivninger TIL igjen til SR, fordi eRFU er etter avskrivninger

    for t in range(0,len(IFU)):
        if(t>0):
            #Vi er altså ikke i år 0
            IFU[t]=min(SSR[t-1],0); #Første år er innkommende fremførbart underskudd fra andre ting enn avskrivninger 0, 
            
        SSR[t]=SR[t]+IFU[t]
   
    for i in range(0,antÅr+1):
        if(i==0):
            BAvsk[i]=min(AVSK[i], max(SSR[i],0)); #Likning 5.7
            SUavsk[i]=AVSK[i]-BAvsk[i]; #Likning 5.8
        elif(i==14):
            SUavsk[i]=sum(AVSK)-sum(BAvsk)
        
        else: 
            BAvsk[i]=min(SUavsk[i-1]+AVSK[i], max(SSR[i],0)); #Likning 5.7
            SUavsk[i]=SUavsk[i-1]+AVSK[i]-BAvsk[i]; #Likning 5.8
            
    output['SUavsk']=SUavsk
  
    for t in range(0,antÅr+1):
        if (sumEiendeler[t]==0):
            startÅr=t+1
        else:
            if printInfo: print("Startår er år ",t)            
            break    
    sluttÅr=antÅr-1
    for t in range(antÅr-1,0,-1) :
        if (sumEiendeler[t]!=0):
            if printInfo: print("Sluttår er år ",t)            
            break    
        else:
           sluttÅr=t-1
           
    for t in range(startÅr,sluttÅr) :
        if (sumEiendeler[t]==0):
            print("Det er et hull i dataserien i år ",t)   
            valid=False
            output['valid']=valid
            return output

    
    for t in range(startÅr,sluttÅr+1):
        eiendeler[t]=sumEiendeler[t]
        if printInfo: print(eiendeler[t],"er eiendeler i år ",t)
    if printInfo: print(eiendeler)
    output['eiendeler']=eiendeler
                    

    if printInfo: print("startÅr: ",startÅr," sluttÅr: ",sluttÅr)
    for t in range(startÅr,sluttÅr+1):
        ROA[t]=(SR[t]/sumEiendeler[t])
        if printInfo: print("t ",t)

    output['ROA']=ROA
    output['startÅr']=startÅr
    output['sluttÅr']=sluttÅr                
    output['AVSK0']=AVS0[antÅr-1]    
    output['AVSK1']=AVS1[antÅr-1]
    output['AVSK2']=AVS2[antÅr-1]
    output['AVSK3']=AVS3[antÅr-1]
    output['AVS0DB']=AVS0DB
    output['AVS1DB']=AVS1DB
    output['AVS2DB']=AVS2DB
    output['AVS3DB']=AVS3DB
    output['valid']=True
    return output
    
    
