<?php

require_once ('CompanyResolver.php');

class CompanyMapper
{
    /** @var CompanyResolver CompanyResolver */
    private $companyResolver;

    public function __construct(CompanyResolver $companyResolver)
    {
        $this->companyResolver = $companyResolver;
    }

    public function mapDataToArray($company, $fileName)
    {
        $orgNr = (int) $company->hode->orgnr;
        $orgForm = (string) $company->hode->orgform;
        if ($this->companyResolver->isCompanyOfInterest($orgNr, $orgForm)) {
            return [
                    'head'  => $this->mapHeadData($company->hode, $fileName),
                    'posts' => $this->mapPostData($company->info)
                ];
        }
        return false;
    }

    private function mapHeadData($heads, $fileName)
    {
        $headData = [];
        foreach ($heads as $head) {
            foreach ($head as $key => $entry) {
                $headData[$key] = (string)$entry;
            }
        }
        $headData['fraArk'] = $fileName;
        return $headData;
    }

    private function mapPostData($posts)
    {
        $postData = [];
        foreach ($posts as $post) {
            $postData[] =
                [
                    'feltkode' => (int)$post->feltkode,
                    'sum'      => (string)$post->sum
                ];
        }
        return $postData;
    }
}
