<?php

require_once ('DatabaseConnector.php');

class CompanyPersister
{
    /**@var $db DatabaseConnector */
    private $db;
    private $queryBuilder;

    public function __construct(DatabaseConnector $db, CompanyQueryBuilder $queryBuilder)
    {
        $this->db = $db;
        $this->queryBuilder = $queryBuilder;
    }

    public function persistCompanyData($data)
    {
        $id = $this->persistCompanyHeadData($data['head']);
        $this->persistCompanyPostData($id, $data['posts']);
    }

    private function persistCompanyHeadData($data)
    {
        try {
            $this->db->query($this->queryBuilder->buildCompanyHeadQuery($data));
        } catch (Exception $e) {
            throw new Exception($e->getMessage());
        }

        return $this->db->getLastInsertedId();
    }

    private function persistCompanyPostData($id, $data)
    {
        try {
            $query = $this->queryBuilder->buildCompanyPostQuery($id, $data);
            $this->db->query($query);
        } catch (Exception $e) {
            throw new Exception($e->getMessage());
        }
    }
}
