<?php

class CompanyQueryBuilder
{
    private $notVarColumns = array('orgnr','regnarr','oppstillingsplan_versjonsnr');

    public function buildCompanyHeadQuery($data)
    {
        $table = "INSERT INTO selskap_hode";
        $header = "";
        $values = "";

        $dataLength = count($data);
        $count = 0;

        foreach ($data as $key => $value) {
            if ($count == 0) {
                $header .= " ($key,";
                $values .= "VALUES (".$this->wrapAsStringIfNeeded($key, $value).", ";
            } else if ($count == $dataLength-1){
                $header .= " $key) ";
                $values .= $this->wrapAsStringIfNeeded($key, $value) . ")";
            } else {
                $header .= " $key,";
                $values .= $this->wrapAsStringIfNeeded($key, $value) . ", ";
            }
            $count++;
        }
        return $table . $header . $values;
    }

    public function buildCompanyPostQuery($id, $data)
    {
        $data_length = count($data);
        $count = 0;
        $query = "INSERT INTO post (feltkode, hode_id, verdi) VALUES ";
        foreach ($data as $key => $entry) {
            $feltkode = $entry['feltkode'];
            $sum = $entry['sum'];
            $count++;
            $query .= "($feltkode, $id, '$sum')";
            if ($count == $data_length) {
                $query .= ";";
            } else {
                $query .= ", ";
            }
        }
        return $query;
    }

    private function wrapAsStringIfNeeded($key, $value)
    {
        if (in_array($key, $this->notVarColumns)) {
            return " $value";
        } else {
            return " '$value'";
        }
    }
}
