<?php

require_once ('DatabaseConnector.php');

class CompanyResolver
{
    /** @var $db DatabaseConnector */
    private $db;
    private $validOrgForms;
    private $companiesOfInterest;

    public function __construct(DatabaseConnector $db, array $validOrgForms)
    {
        $this->validOrgForms = $validOrgForms;
        $this->db = $db;
        try {
            $this->getCompaniesFromDB();
        } catch (Exception $e){
            if ($this->db) {
                $this->db->close();
            }
            throw new Exception($e->getMessage());
        }
    }

    public function isCompanyOfInterest($orgNumber, $orgForm)
    {
        if ($this->IsValidOrgForm($orgForm)) {
            return in_array($orgNumber, $this->companiesOfInterest);
        }
        return false;
    }

    private function IsValidOrgForm($orgForm)
    {
        if (in_array($orgForm, $this->validOrgForms)) {
            return true;
        }
        return false;
    }

    private function getCompaniesFromDB()
    {
        try {
            $result = $this->db->query("SELECT id FROM selskap");
            while($row = $result->fetch_row()) {
                $this->companiesOfInterest[] = $row[0];
            }
            $result->close();
        } catch (Exception $e) {
            throw new Exception($e->getMessage());
        }
    }
}

